// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.




//Imports From SimCommands.cs
using Eco.Core.Tests;
using Eco.Gameplay.Players;
using Eco.Shared.Localization;
using Eco.Shared.Math;
using Eco.Shared.Services;
using Eco.Gameplay.Systems.Chat;
using Eco.Shared.Utils;
using Eco.Simulation.WorldLayers;
using Eco.World;
using Eco.Shared.Voxel;
using Eco.Simulation.Agents.AI;
using System;
using System.Collections.Generic;
using System.Runtime.CompilerServices;
//-------------------------------

namespace Eco.Mods
{


    public class Arashi_ConsoleCommands : IChatCommandHandler
    {

		//Admin Commands
		
        [ChatCommand("Iterates through the world given the maxDepth value and deletes Tailings.", ChatAuthorizationLevel.Admin)]
        public static void TailingsBeGone(User user, int maxDepth)
        {
		
		user.Player.SendTemporaryMessage(Localizer.DoStr("Arashi's Program Started: Tailing Remover Will Now Attempt To Destroy This Worlds Tailing Blocks, This May Take A Few Minutes."));
		Array2D<Block> worldSurface = World.World.TopBlockCache;
		
	
		
		
		
		
		// F# code iterates through the worldSurface Array and collects each world position and game object held within
		worldSurface.ForEach((SurfaceLocation, target) =>
		{ 
		var targetLocation 	= World.World.GetTopPos(SurfaceLocation); 
		var targetBlock = World.World.GetBlock(targetLocation);
		if(targetBlock.GetType().Name == "TailingsBlock" )
		{
			World.World.DeleteBlock(targetLocation);
		}
		
		var targetLocationDepth = targetLocation;
		for(int y =0; y < maxDepth; y++)
		{
		targetLocationDepth = targetLocationDepth + Vector3i.Down;
		targetBlock = World.World.GetBlock(targetLocationDepth);
		
		if(targetBlock.GetType().Name == "TailingsBlock" )
		{
			World.World.DeleteBlock(targetLocationDepth);
		}
		}					
		});			
        
		user.Player.SendTemporaryMessage(Localizer.DoStr("Arashi's Program Finished: Tailings Which Are " + maxDepth + " Blocks From The Surface Have Been Removed"));
		
		
		}		

		
		
				
		
		
		

    }
	
	
	
}